Annotation of openbsd/fw_update/fw_install.sh, Revision 1.19
1.1 afresh1 1: #!/bin/ksh
2: set -e
3:
4: scan_dmesg() {
5: # no bsort for now
6: sed -n "$1" /var/run/dmesg.boot
7: }
8:
1.8 afresh1 9: # tmpdir, do_as, unpriv, and unpriv2 are from install.sub
10:
11: # Create a temporary directory based on the supplied directory name prefix.
12: tmpdir() {
13: local _i=1 _dir
14:
15: until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
16: ((++_i < 10000)) || return 1
17: done
18: echo "$_dir"
19: }
1.6 afresh1 20:
21: # Run a command ($2+) as unprivileged user ($1).
22: # Take extra care that after "cmd" no "user" processes exist.
23: #
24: # Optionally:
25: # - create "file" and chown it to "user"
26: # - after "cmd", chown "file" back to root
27: #
28: # Usage: do_as user [-f file] cmd
29: do_as() {
30: (( $# >= 2 )) || return
31:
32: local _file _rc _user=$1
33: shift
34:
35: if [[ $1 == -f ]]; then
36: _file=$2
37: shift 2
38: fi
39:
40: if [[ -n $_file ]]; then
41: >$_file
42: chown "$_user" "$_file"
43: fi
44:
45: doas -u "$_user" "$@"
46: _rc=$?
47:
48: while doas -u "$_user" kill -9 -1 2>/dev/null; do
49: echo "Processes still running for user $_user after: $@"
50: sleep 1
51: done
52:
53: [[ -n $_file ]] && chown root "$_file"
54:
55: return $_rc
56: }
57:
58: unpriv() {
59: do_as _sndio "$@"
60: }
61:
62: unpriv2() {
63: do_as _file "$@"
64: }
65:
1.8 afresh1 66: _issue=
67: fail() {
68: echo $_issue >&2
69: exit 1
70: }
71:
1.7 afresh1 72: VNAME=$(sysctl -n kern.osrelease)
73: VERSION="${VNAME%.*}${VNAME#*.}"
74: FWDIR="$VNAME"
1.1 afresh1 75:
1.14 afresh1 76: # TODO: We need the firmware for the system we just installed
77: # not the one we booted from. For example:
78: # * booting from a snapshot bsd.rd that thinks it is the 7.0 release
79: # will install the firmware from the 7.0 directory instead of
80: # from the snapshots dir.
81: # If they're using sysupgrade, then the installer kernel will be correct.
82: # If we're doing this in the installer we can check what they picked
83: # for downloading sets and use that value.
84: # Otherwise, the fw_update after first boot will fix it up for us.
85:
1.7 afresh1 86: HTTP_FWDIR=$FWDIR
87: set -- $(scan_dmesg "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p")
88: [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots
89:
90: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
91: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.1 afresh1 92: PKGDIR=${DESTDIR}/var/db/pkg
93: PATTERNS="file:${0%/*}/firmware_patterns"
94:
1.11 afresh1 95: fw_update() {
1.15 afresh1 96: local _tmpsrc _f _r _remove _i _installed
1.12 afresh1 97: local _src=$FWURL _t=Get _cfile="/tmp/SHA256" _srclocal=false
1.15 afresh1 98: local _d _drivers=$(
1.11 afresh1 99: last=''
100: ftp -D "Detecting" -Vmo- $PATTERNS |
1.15 afresh1 101: while read _d _m; do
1.11 afresh1 102: grep=grep
1.15 afresh1 103: [ "$last" = "$_d" ] && continue
104: [ "$_m" ] || _m="^$_d[0-9][0-9]* at "
105: [ "$_m" = "${_m#^}" ] && grep=fgrep
106: $grep -q "$_m" /var/run/dmesg.boot || continue
107: echo $_d
108: last=$_d
1.11 afresh1 109: done
110: )
111:
112: if [ -z "$_drivers" ]; then
113: echo "No devices found which need firmware files to be downloaded." >&2
114: return
115: fi
1.1 afresh1 116:
1.11 afresh1 117: if _tmpsrc=$( tmpdir "${DESTDIR}/tmp/fw_update" ); then
118: (
119: >$_tmpsrc/t &&
120: $_unpriv cat $_tmpsrc/t
121: ) >/dev/null 2>&1 ||
122: rm -r $_tmpsrc
123: fi
1.1 afresh1 124:
1.11 afresh1 125: [[ ! -d $_tmpsrc ]] &&
126: _issue="Cannot create prefetch area" && fail
1.1 afresh1 127:
1.16 afresh1 128: # Cleanup from previous runs.
129: rm -f $_cfile $_cfile.sig
130:
1.17 afresh1 131: _t=Get/Verify
132:
1.11 afresh1 133: ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&
134: _issue="Cannot fetch SHA256.sig" && fail
1.1 afresh1 135:
1.11 afresh1 136: # Verify signature file with public keys.
137: ! unpriv -f "$_cfile" \
138: signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&
139: _issue="Signature check of SHA256.sig failed" && fail
140:
1.15 afresh1 141: for _d in $_drivers; do
142: _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )
1.19 ! afresh1 143: _installed=$(
! 144: for fw in "${PKGDIR}/$_d-firmware"*; do
! 145: [ -e "$fw" ] || continue
! 146: echo ${fw##*/}
! 147: done
! 148: )
1.15 afresh1 149:
150: for _i in $_installed; do
151: if [ "$_f" = "$_i.tgz" ]; then
152: echo "Firmware for $_d already installed ($_installed)"
1.11 afresh1 153: continue 2
1.1 afresh1 154: fi
155: done
156:
1.11 afresh1 157: rm -f /tmp/h /tmp/fail
158:
159: # Fetch firmware file and create a checksum by piping through
160: # sha256. Create a flag file in case ftp failed. Firmware
161: # from net is written to the prefetch area.
162: ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |
163: ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||
164: unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )
165:
166: # Handle failed transfer.
167: if [[ -f /tmp/fail ]]; then
168: rm -f "$_tmpsrc/$_f"
169: _issue="Fetching of $_f failed!"
170: fail
171: fi
172:
173: # Verify firmware by comparing its checksum with SHA256.
174: if fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then
175: #_unver=$(rmel $_f $_unver)
176: true
177: else
178: [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"
179: _issue="Checksum test for $_f failed."
180: fail
181: fi
182:
183: # TODO: Check hash for files before deleting
1.18 afresh1 184: if [ "$_installed" ] && [ -e "${PKGDIR}/$_installed/+CONTENTS" ]; then
185: echo "Uninstalling $_installed"
186: cwd=${PKGDIR}/$_installed
1.11 afresh1 187:
188: set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"
189:
190: while read c g; do
191: case $c in
1.13 afresh1 192: @cwd) cwd="${DESTDIR}/$g"
1.11 afresh1 193: ;;
194: @*) continue
195: ;;
196: *) set -A _remove -- "$cwd/$c" "${_remove[@]}"
197: ;;
198: esac
1.18 afresh1 199: done < "${PKGDIR}/$_installed/+CONTENTS"
1.11 afresh1 200:
201: for _r in "${_remove[@]}" ; do
202: if [ -d "$_r" ]; then
203: # Try hard not to actually remove recursively
204: # without rmdir on the install media.
205: [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"
206: else
207: rm -f "$_r"
208: fi
209: done
210: fi
211:
212: # TODO: Add some details about the install to +CONTENTS like pkg_add
213: # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall
214: echo "Installing $_f"
1.13 afresh1 215: tar -zxphf "$_tmpsrc/$_f" -C "${DESTDIR}/etc" "firmware/*"
1.11 afresh1 216: mkdir -p ${PKGDIR}/${_f%.tgz}/
1.12 afresh1 217: tar -zxphf "$_tmpsrc/$_f" -C "${PKGDIR}/${_f%.tgz}" "+*"
1.11 afresh1 218: ed -s "${PKGDIR}/${_f%.tgz}/+CONTENTS" <<EOL
1.1 afresh1 219: /^@comment pkgpath/ -1a
220: @option manual-installation
221: @option firmware
222: @comment install-script
223: .
224: w
225: EOL
1.11 afresh1 226: done
227: }
1.1 afresh1 228:
1.11 afresh1 229: fw_update
FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>